package io.flutter.plugins

import android.app.Activity
import android.content.Context
import android.os.Build
import android.util.Log
import android.widget.Toast
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

class NXToastPlugin() : FlutterPlugin, MethodChannel.MethodCallHandler, ActivityAware {

    companion object {
        private var channel: MethodChannel? = null
        const val CHANNEL = "flutter_plugin_nxtoast"

        fun registerWith(engine: FlutterEngine) {
            Log.e("NXToastPlugin", "registerWith")
            channel = MethodChannel(engine.dartExecutor.binaryMessenger, CHANNEL)
            channel!!.setMethodCallHandler(NXToastPlugin())
        }
    }

    var engine: FlutterEngine? = null
    var binaryMessage: BinaryMessenger? = null
    var applicationContext: Context? = null
    var activity: Activity? = null

    override fun onAttachedToEngine(binding: FlutterPlugin.FlutterPluginBinding) {
        Log.e("NXToastPlugin", "onAttachedToEngine")
        engine = binding.flutterEngine
        binaryMessage = binding.binaryMessenger
        applicationContext = binding.applicationContext
        channel = MethodChannel(engine!!.dartExecutor.binaryMessenger, CHANNEL)
        channel!!.setMethodCallHandler(NXToastPlugin())
    }

    override fun onDetachedFromEngine(binding: FlutterPlugin.FlutterPluginBinding) {
        Log.e("NXToastPlugin", "onDetachedFromEngine")
        engine = null
        binaryMessage = null
        applicationContext = null
        channel = null
    }

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        Log.e("NXToastPlugin", "onMethodCall:" + call.method)

        when (call.method) {
            "getVersion" -> {
                result.success("Android2222 " + Build.VERSION.RELEASE)
            }
            "nxToast" -> {
                Toast.makeText(applicationContext, "Mother Fxxker!!", Toast.LENGTH_LONG).show()
            }
            else -> {
                result.notImplemented()
            }
        }
    }

    override fun onDetachedFromActivity() {
        Log.e("NXToastPlugin", "onDetachedFromActivity")
        activity = null
    }

    override fun onReattachedToActivityForConfigChanges(binding: ActivityPluginBinding) {
        Log.e("NXToastPlugin", "onReattachedToActivityForConfigChanges")
    }

    override fun onAttachedToActivity(binding: ActivityPluginBinding) {
        Log.e("NXToastPlugin", "onAttachedToActivity")
        activity = binding.activity
    }

    override fun onDetachedFromActivityForConfigChanges() {
        Log.e("NXToastPlugin", "onDetachedFromActivityForConfigChanges")
    }
}